﻿/* 
 * Ewald Kendziorra sr, 2015, http://kendziorra.nl
 * License: Free
 * Publishing: Only with this header
 * Editing: Free
 * Guarantee: No
 * Using: At your own risk
 * Support: No
 */
 
var websocket;
var isConnected = false;

/********** is WebSockets alive **********/
$(document).ready(function () {        
    setInterval(openWebSocket, 5000);
});
 
function openWebSocket() {
  if (stopWS) return;  // user stopped the connection 
  websocket.send(" ");
  if (websocket == null || websocket.readyState == undefined || websocket.readyState != 1) {
    init();
  }
}

/********** WEBSOCKET **********/
function init() {
  var wsUri = 'ws://' + socketIP + ':' + socketPort + '/' ;
  websocket = new WebSocket(wsUri, [wsProtocol]);
  websocket.onopen = function(evt) { onOpen(evt) }; 
  websocket.onclose = function(evt) { onClose(evt) }; 
  websocket.onmessage = function(evt) { onMessage(evt) }; 
  websocket.onerror = function(evt) { onError(evt) }; 
}   

function onOpen(e) {
  isConnected = true;
  disCon();
}

function onClose(e) {
  isConnected = false;
  disCon();
}

function onMessage(e) {
  var str = e.data.replace('\0', '');
  commandMsg(str);
}

function onError(e)
{
  var str = e.type.replace('\0', '');
  errorMsg(str);
}

function publish(msg) {
  if (msg.length > 1) websocket.send(msg);
}
