var socketIP = networkSTA;  // Station mode
var stopWS = true;  // true: avoid automatic connection
var rbutton = 'rbnSTA';  // holt active radio button

/********** proceed data **********/
function commandMsg(msg) {  // is used by WebsocketClient.js
  if (!(msg.startsWith('|') && msg.endsWith('|'))) return;
  doMsg(msg);
}

/********** network radio buttons **********/
$('input[type=radio]').change(function(e) {
  if (!isConnected) {
    if (this.id == 'rbnSTA') {
      socketIP = networkSTA;
      rbutton = 'rbnSTA';
    } else {
      socketIP = networkWWW;
      rbutton = 'rbnWww';
    }
  }
  else $('#' + rbutton ).prop('checked', true);
});

/********** dis/connect buttons **********/
$('#btnConnect').click(function() {
  if (!isConnected) {   // connect to server
    stopWS = false;
    if (!isConnected) init();
  }
  else {  // disconnect fom server
    stopWS = true;
    if (isConnected) {
      websocket.close();
      websocket = null; 
    }
  }
});

/********** commands **********/
var numberOfItems = 11;  // the number of used None Items 
var addrItemGet = [['000000', 2, 'lampK1'],   // 0: address Node, item number, item name
                   ['000000', 1, 'screen'],   // 1
                   ['000100', 1, 'lamp'], 
                   ['000100', 2, 'home'], 
                   ['000101', 1, 'lamp'], 
                   ['000101', 2, 'home'], 
                   ['000001', 1, 'boiler'], 
                   ['010000', 1, 'lamp'], 
                   ['010010', 1, 'lamp'], 
                   ['010011', 1, 'pump'],
                   ['000002', 1, 'heat']];   // 10
                   
$('input[type=button]').click(function(e) {
  var msg;
  var adr = this.id.substr(0, 6);
  var pos = this.id.substr(6);
  if (isConnected) {
    if (adr == 'getBtn') {
      msg = '|' + addrItemGet[pos][0] + '|WS|LIST|' + addrItemGet[pos][1] + '|';
      $('#publish').text(msg);
      publish(msg);
    }
    else if (adr == 'setBtn') {
      var rgb = $('#rg'+ pos).css('color');
      if ($('#rg'+ pos).css('color').substr(4, 1) == '0') {
        msg = '|' + addrItemGet[pos][0] + '|WS|name|' + addrItemGet[pos][2] + '|status|' + ($('#onChb'+ pos).prop('checked') ? 1 : 0) + '|pause|' + ($('#pauseChb'+ pos).prop('checked') ? 1 : 0) + '|mode|' + $('#modeSlct'+ pos).prop('selectedIndex') + '|';
        $('#publish').text(msg);
        publish(msg);
      }
      else $('#publish').text('Use the get-button!');
    }
  }
  else $('#publish').text('NOT CONNECTED!');
});

function doMsg(msg) {
// |WS|000000|LIST|1|name|....etc....|
//           1111111111
// 01234567890123456789
  var pos = -1;
  var lst = msg.substr(11, 4);
  if (lst == 'LIST') {
    var adr = msg.substr(4, 6);
    var item = msg.substr(16,1);
    for (i = 0; i < numberOfItems; i++) {
      if (addrItemGet[i][0] == adr && addrItemGet[i][1] == item) {
        pos = i;
        $('#rg' + pos).css('color', 'green');
        break;
      }
    }
    if (pos == -1) $('#rg' + pos).css('color', 'red');  // not online or error
    else {
      var statusPos = msg.search('status');
      var pausePos =  msg.search('pause');
      var modePos =   msg.search('mode');
      var status =    parseInt(msg.substr(statusPos + 7));
      var pause =     parseInt(msg.substr(pausePos + 6));
      var mode =      parseInt(msg.substr(modePos + 5));
      $('#onChb' + pos).prop( "checked", (status ? true : false));
      $('#pauseChb' + pos).prop( "checked", (pause ? true : false));
      $('#modeSlct' + pos).prop('selectedIndex', mode);
    }
  }
}
  
/********** diverse **********/
function errorMsg(error) {  // show Websocket error
  $('#respons0').text(error);
}

function disCon() {  // show connected or disconnected
   if (isConnected) {   // connect to server
    $('#btnConnect').text('DisConnect');
    $('#ledPic').attr('src', 'myST_Include/green.jpg');
  }
  else {  // disconnect fom server
    $('#btnConnect').text('Connect');
    $('#ledPic').attr('src', 'myST_Include/red.jpg');
    setRed();
  }
}

function setRed() {
  for (pos = 0; pos < numberOfItems; pos++) $('#rg' + pos).css('color', 'red');  // not online 
}
