///////////////////////////////////////////////////////////////////////////////
// general used code: WiFi, NTP, DST, SUN, OTA from loop() and other actions //
///////////////////////////////////////////////////////////////////////////////

///////////////////////////
// here is nothing to do //
///////////////////////////

#ifndef _MY_ST_GEN_H_
#define _MY_ST_GEN_H_

#include <myST_Func.h>
#include "myST_Node.h"
#include "myST_Start.h"   // your own on-start code:   read and set begin or last status on a (re)start
#include "myST_Action.h"  // your own on-action code:  one minutes actions from loop()
#include "myST_Cmd.h"     // your own on-command code: execute commands from WebSocket and/or other Nodes

void setup() {
  Serial.begin(115200);
  Serial.println("\n");
  touchAttachInterrupt(OTA_Pin, OTA_Interrupt, threshold);
  sprintf(now_SSID, "%s%s", now_SSID, now_Address);
  ntpTime(true, true);  // get the time (and DST/SummerTime)
  EEPROM.begin(8 + maxItemLen * nItems);  // 0,:OTA, 1,6:usedAddress, 7:useDST, 8+:the myThings.h Item values
  EEPROM.write(0, EEPROM.read(0) + 1);  // set OTA flag, a second restart within one minute put the Node in the OTA  mode
  EEPROM.commit();
  if (!now_initEspnow()) {
    time_t t = now() + 5000;  // hopla....
    while(1) {  // ENDLESS LOOP
      if (now() > t) {
        Serial.printf("## ESP-NOW INIT PROBLEM ##\n SSID:%s, Address:%s, Channel:%d \n", now_SSID, now_Address, now_Channel);
        t = now() + 5000;
      }
    }
  }
  readTest();      // test for Items from EEPROM
  nowTimes();      // calc all the times we need
  /** extra INIT actions in "myST_func.h"-fromSetup() **/
  fromSetup();
  onStart();       // first to do?
  sprintf(msg[0], "|WS|%s|ESP-NOW started|%s|", now_Address, now_SSID);
  sendTo(msg[0]);
  saveMitute = minute();
  uint8_t macAddr[6];
  WiFi.macAddress(macAddr);
  Serial.printf("   STA MAC: %02x:%02x:%02x:%02x:%02x:%02x\n", macAddr[0], macAddr[1], macAddr[2], macAddr[3], macAddr[4], macAddr[5]);
  WiFi.softAPmacAddress(macAddr);
  Serial.printf("    AP MAC: %02x:%02x:%02x:%02x:%02x:%02x\n", macAddr[0], macAddr[1], macAddr[2], macAddr[3], macAddr[4], macAddr[5]);
  Serial.printf("- ESP-NOW %s started -\n", now_SSID);
}

void loop() {
    if (waitForOTA) {  // wait for OTA?
    ArduinoOTA.handle();
    if (now() > otaTime) {  // wait max. 5 minutes for OTA firmware upload
      waitForOTA = false;   // no upload  ...
      now_espnowOn();           // ... re-start ESP-NOW
    }
    if (saveMitute != minute()) {
      Serial.printf("%02d:%02d\n", minute(), second());
      saveMitute = minute();
    }
    yield();
    return;
  }
  if(OTA_Detect == 1) {
    OTA_Detect = now() + 2000;
    setOTA();
  }
  if (OTA_Detect && (now() >= OTA_Detect)) OTA_Detect = 0;
  /** extra actions in "myST_Node.h"-fromLoop_1() **/
  fromLoop_1();
  /** test for action time **/  
  if (saveMitute != minute()) {  // a new minute?
    if (flagOTA) {  // reset OTA on restart flag
      flagOTA = false;
      if (EEPROM.read(0)) {
        EEPROM.write(0, 0);  // reset OTA flag
        EEPROM.commit();
      }
    }
    nowTimes();                  // calc all the times we need
    if (newDay) {    // reset paused Items on 04:00 night
      for (uint8_t i = 0; i < nItems; i++) strcpy(itemValues[i][nPause], "0");
      saveIt = true;
      newDay = false; 
    }
    onAction();                  // see if there what to do?
    saveMitute = minute();       // next minute: repeat onAction()
  }
  if (saveIt) writeItems();
  if (now_msgInQueue) onCommand();  // a message from WebSocket Client or other ESP-NOW Node?
  /** extra actions in "myST_Node.h"-fromLoop_2() **/
  fromLoop_2();
  yield();
}

/** unused itemValues[] must have a <mypace> **/
void insertSpace(uint8_t item) { 
  if (item >= nItems) return;
  for (uint8_t i = 0; i < nFields; i++) if (strlen(itemValues[item][i]) == 0) itemValues[item][i][0] = ' ';
}

/** item: enum name, len: number of items in list, flds: list of fields to merge **/
boolean mergList(uint8_t item, uint8_t len, uint8_t *flds) {  // make a list with names and values (set positions in flds)
  msg[0][0] = '\0';
  if (item >= nItems) return false;
  char c[nMaxChars * 2];
  insertSpace(item);
  sprintf(msg[0], "|%s|%s", itemNames[item][0], itemValues[item][0]);
  for (uint8_t i = 0; i < len; i++) {
    sprintf(c, "|%s|%s", itemNames[item][flds[i]], itemValues[item][flds[i]]);
    strcat(msg[0], c);
  }
  strcat(msg[0], "|");
  return true;
}

/** item: enum name to merg all fields **/  
boolean mergAll(uint8_t item) {
  uint8_t n = itemFields[item]; 
  uint8_t flds[n - 1];
  for (uint8_t i = 1; i < n; i++) flds[i - 1] = i;
  return mergList(item, sizeof(flds), flds);
}

/** (re)set the Item values **/
void readOrgValues() {
  for (uint8_t i = 0; i < nItems; i++) {
    for (uint8_t ii = 0; ii < nFields; ii++) strcpy(itemValues[i][ii], itemValOrg[i][ii]);
  }
}

/**  EEPROM read/write Items **/
void writeItems() {
  EEPROM.write(7, useDST);
  char c[maxItemLen];
  for (uint8_t i = 0; i < nItems; i++) {
    strcpy(c, "|");
    for (uint8_t ii = 0; ii < nFields; ii++) {
      strcat(c, itemValues[i][ii]);
      strcat(c, "|");
    }
    uint16_t addr = eepromAddr[i];
    uint8_t len = strlen(c);
    EEPROM.write(addr++, len);
    for (uint8_t ii = 0; ii < len; ii++) EEPROM.write(addr++, c[ii]);
  }
  EEPROM.commit();
  saveIt = false;
}

void readItems() {
  // first time read? then write it and return 
  char c[maxItemLen];
  useDST = EEPROM.read(7);
  for (uint8_t i = 0; i < nItems; i++) {
    uint16_t addr = eepromAddr[i];
    uint8_t len = EEPROM.read(addr++);
    for (uint8_t ii = 0; ii < len; ii++) c[ii] = EEPROM.read(addr++);
    c[len] = '\0';
    uint8_t n = 0;
    char * v;
    /** get the number of fields **/
    v = strchr(c, '|');
    while (v != NULL) {
      n++;
      v = strchr(v + 1, '|');
    }
    yield();
    if (n > 3 && (n % 2 != 0)) { // <= 3:no data, 'n' not neg. wrong format
      uint8_t ii = 0;
      /** get only the itemValues fields **/
      v = strtok (c, "|");
      while (v != NULL) {
        strcpy(itemValues[i][ii++], v);
        v = strtok (NULL, "|");
      }          
    }
  }
}

/** EEPROM OK? **/
void readTest() {
  uint8_t ota = EEPROM.read(0);
  if (ota > 2) {
    EEPROM.write(0, 0);
    EEPROM.commit();
  }
  else if (ota == 2) {
    Serial.println("##### OTA mode: 5 min. time window to upload #####");
    setOTA();
    return;
  }
  boolean ok = true;
  /** set init values **/
  readOrgValues();
  /** the Node ID ok? **/
  for (uint8_t i = 1; i < 7; i++) {
    if (EEPROM.read(i) != now_Address[i - 1]) {
      Serial.println("WRONG NODE ID, write and use the INIT values!");
      for (uint8_t ii = 1; ii < 7; ii++) EEPROM.write(ii, now_Address[ii - 1]);
      EEPROM.commit();
      ok = false;
      break;
    }
  }
  /** test the Items name labels **/
  if (ok) {
    for (uint8_t i = 0; i < nItems; i++) {
      uint16_t addr = eepromAddr[i] + 2;
      for (uint8_t ii = 0; ii < strlen(itemValues[i][0]); ii++) {
        if (EEPROM.read(addr++) != itemValues[i][0][ii]) {
          ok = false;
          break;
        }
      }
      if (!ok) break;
    }
  }
  if (ok) readItems();
  else writeItems();
}

void doOTA() {
  if (now_msgInQueue == now_msgQueueLen) {  // queue full?
    for (uint8_t i = 1; i < now_msgQueueLen; i++) strcpy(now_msgQueue[i - 1], now_msgQueue[i]); // delete oldest msg
    now_msgInQueue--;
  }
  EEPROM.write(0, 0);
  EEPROM.commit();
  char ms[18] = {"|WS|"};
  strcat(ms, now_Address);
  strcat(ms, "|OTA|.|");
  strcpy(now_msgQueue[now_msgInQueue++], ms);
}

#endif
