////////////////////////////////////////////////////////////////////
// on-start code: read and set (last) Item(s) status on (re)start //
////////////////////////////////////////////////////////////////////

#ifndef _MY_ST_START_H_
#define _MY_ST_START_H_

#include "myST_Gen.h"

/** add your own "on start" code **/
void onStart() {  // once caled by setup()
  for (uint8_t i = 0; i < nItems; i++) {
    if (atoi(itemValues[i][nPause])) {  // if paused: set in the saved last state?
      if (i == nScreen) {
        strcpy(itemValues[nScreen][nStatus], "0");  // set value to UP
        screenDownUp(nScreen);  // optocoupler bridge, on start always UP (status 0)
        saveIt = true;
      }
      else if (i == nLampK1) kakuOffOn(nLampK1); 
    }
    else if (atoi(itemValues[i][nMode])){  // set on time or/and ...?
      if (i == nScreen) {
        strcpy(itemValues[nScreen][nStatus], "0");  // set value to UP
        screenDownUp(nScreen);  // optocoupler bridge, on start always UP (status 0)
        saveIt = true;
      }
      else if (i == nLampK1) {
        // USING TIME TEST: uint8_t timesTest(time_t testTime, time_t timeFrom, time_t timeTo, boolean between) return NO/OFF/ON
        // between false: if testTime is timeFrom return ON, if testTime is= timeTO return OFF, else return NO
        // between true:  if testTime is between timeFrom and timeTo return ON else return OFF
        uint8_t n0 = timesTest(dayTime, (atoi(itemValues[nLampK1][nOnHH2]) * 3600 + atoi(itemValues[nLampK1][nOnMM2]) * 60), (dayRise + atoi(itemValues[nLampK1][nRise2]) * 60), true);  // true: between Start to END time
        uint8_t n1 = timesTest(dayTime, (daySet - atoi(itemValues[nLampK1][nSet2]) * 60), (atoi(itemValues[nLampK1][nOffHH2]) * 3600 + atoi(itemValues[nLampK1][nOffMM2]) * 60), true);
        uint8_t m = atoi(itemValues[nLampK1][nMode]);  // mode: 1,2 or 3?
        if (m == 1 || m == 3) strcpy(itemValues[nLampK1][nStatus], String(n0).c_str());  // n0: morning
        if (m == 2 || m == 3) strcpy(itemValues[nLampK1][nStatus], String(n1).c_str());  // n1: evening
        kakuOffOn(nLampK1);
        saveIt = true;
      }
    }
  }
}

#endif
