////////////////////////////////////////////////////////
// on-action code: time and other actions from loop() //
////////////////////////////////////////////////////////

#ifndef _MY_ST_ACTION_H_
#define _MY_ST_ACTION_H_

#include "myST_Gen.h"

//** add your own "on action" code **/
void onAction() {  // every minute called by loop()
  for (uint8_t i = 0; i < nItems; i++) {
    if (!atoi(itemValues[i][nPause]) && atoi(itemValues[i][nMode])) {  // NOT paused and mode > ZERO
      // USING TIME TEST: uint8_t timesTest(time_t testTime, time_t timeFrom, time_t timeTo, boolean between)
      // between false: timeFrom return ON, timeTO return OFF, else return NO
      // between true:  timeFrom to timeTo return ON else return OFF
      uint8_t n = atoi(itemValues[i][nStatus]);
      if (i == nLamp) {
        n = timesTest(dayTime, (daySet + atoi(itemValues[i][nRise1]) * 60), (dayRise - atoi(itemValues[i][nSet1]) * 60), false);  // true: between Start to END time
        if (n <= ON) digitalWrite(lampPin, !n);  // lamp ON/OFF
      }
      if (i == nHome) {
        n = timesTest(dayTime, (atoi(itemValues[nHome][nOnHH2]) * 3600 + atoi(itemValues[nHome][nOnMM2]) * 60), (atoi(itemValues[nHome][nOffHH2]) * 3600 + atoi(itemValues[nHome][nOffMM2]) * 60), false);  // true: between Start to END time
        if (n == ON) flashPin = redPin;
        else if (n == OFF) flashPin = greenPin;
        atHomeLedOff();
        // sendAtHome();  // if send commands to other Nodes???
        // ... other home commands?
      }
      if (n <= ON && atoi(itemValues[i][nStatus]) != n) { 
        strcpy(itemValues[i][nStatus], String(n).c_str());
        saveIt = true;
      }
    }
  }
}

#endif