////////////////////////////////////////////////////////////////////
// on-start code: read and set (last) Item(s) status on (re)start //
////////////////////////////////////////////////////////////////////

#ifndef _MY_ST_START_H_
#define _MY_ST_START_H_

#include "myST_Gen.h"

/** add your own "on start" code **/
void onStart() {  // once caled by setup()
  for (uint8_t i = 0; i < nItems; i++) {
    uint8_t n = atoi(itemValues[i][nStatus]);
    if (atoi(itemValues[i][nPause])) {  // if paused: set in the saved last state?
      if (i == nLamp) {
        digitalWrite(lampPin, !n);  // lamp ON/OFF 
      }
      else if (i == nHome) {
        if (n) flashPin = redPin;
        else flashPin = greenPin; 
        sendAtHome();  // if send commands to other Nodes???
      }
    }
    else if (atoi(itemValues[i][nMode])){  // set on time or/and ...?
      // USING TIME TEST: uint8_t timesTest(time_t testTime, time_t timeFrom, time_t timeTo, boolean between)
      // between false: timeFrom return ON, timeTO return OFF, else return NO
      // between true:  timeFrom to timeTo return ON else return OFF
      if (i == nLamp) {
        n = timesTest(dayTime, (daySet + atoi(itemValues[i][nRise1]) * 60), (dayRise - atoi(itemValues[i][nSet1]) * 60), true);  // true: between Start to END time
        if (n <= ON) digitalWrite(lampPin, !n);  // lamp ON/OFF
      }
      if (i == nHome) {
        n = timesTest(dayTime, (atoi(itemValues[nHome][nOnHH2]) * 3600 + atoi(itemValues[nHome][nOnMM2]) * 60), (atoi(itemValues[nHome][nOffHH2]) * 3600 + atoi(itemValues[nHome][nOffMM2]) * 60), true);  // true: between Start to END time
        if (n == ON) flashPin = redPin;
        else if (n == OFF) flashPin = greenPin;
        atHomeLedOff();
        // sendAtHome();  // if send commands to other Nodes???
        // ... other home commands?
      }
      if (n <= ON && atoi(itemValues[i][nStatus]) != n) { 
        strcpy(itemValues[i][nStatus], String(n).c_str());
        saveIt = true;
      }
    }
  }
}

#endif
