////////////////////////////////////////////////////////////////////
// on-start code: read and set (last) Item(s) status on (re)start //
////////////////////////////////////////////////////////////////////

#ifndef _MY_ST_START_H_
#define _MY_ST_START_H_

#include "myST_Gen.h"

/** add your own "on start" code **/
void onStart() {  // once caled by setup()
  for (uint8_t i = 0; i < nItems; i++) {
    uint8_t n = atoi(itemValues[i][nStatus]);
    if (atoi(itemValues[i][nPause])) {  // if paused: set in the saved last state?
      if (i == nLamp) {
        digitalWrite(lampPin, !n);  // lamp ON/OFF 
      }
      else if (i == nFlash) {
        digitalWrite(flashPin, !n);  // flash ON/OFF 
      }
      else if (i == nLaser) {
        digitalWrite(laserPin, !n);  // laser ON/OFF 
      }
    }
    else if (atoi(itemValues[i][nMode])){  // set on time or/and ...?
      // USING TIME TEST: uint8_t timesTest(time_t testTime, time_t timeFrom, time_t timeTo, boolean between)
      // between false: timeFrom return ON, timeTO return OFF, else return NO
      // between true:  timeFrom to timeTo return ON else return OFF
      if (i == nLamp) {
        uint8_t n0 = timesTest(dayTime, (atoi(itemValues[i][nOnhh1]) * 3600 + atoi(itemValues[i][nOnmm1]) * 60), (dayRise + atoi(itemValues[i][nRise1]) * 60), true);  // true: between Start to END time
         uint8_t n1 = timesTest(dayTime, (daySet - atoi(itemValues[i][nSet1]) * 60), (atoi(itemValues[i][nOffhh1]) * 3600 + atoi(itemValues[i][nOffmm1]) * 60), true);
        uint8_t m = atoi(itemValues[nLamp][nMode]);  // mode: 1,2 or 3?
        if (m == 1 || m == 3) n = n0;  // n0: morning
        if (m == 2 || m == 3) n = n1;  // n1: evening
        digitalWrite(lampPin, !n);  // lamp ON/OFF
      }
      else if (i == nFlash) {
        n = timesTest(dayTime, (atoi(itemValues[i][nOnhh2]) * 3600 + atoi(itemValues[i][nOnmm2]) * 60), (atoi(itemValues[i][nOffhh2]) * 3600 + atoi(itemValues[i][nOffmm2]) * 60), true);  // true: between Start to END time
        digitalWrite(flashPin, !n);  // flash ON/OFF 
      }
      else if (i == nLaser) {
        n = timesTest(dayTime, (daySet + atoi(itemValues[i][nRise3]) * 60), (dayRise - atoi(itemValues[i][nSet3]) * 60), true);  // true: between Start to END time
        digitalWrite(laserPin, !n);  // lamp ON/OFF
      }
      if (n <= ON && atoi(itemValues[i][nStatus]) != n) { 
        strcpy(itemValues[i][nStatus], String(n).c_str());
        saveIt = true;
      }
    }
  }
}


#endif
